import{S as qn,i as Tn,s as Nn,e as n,k as p,w as _,t as l,M as yn,c as s,d as t,m as u,a,x as g,h as i,b as d,$ as On,G as o,g as m,y as v,L as kn,q as w,o as b,B as x,v as En}from"../../../chunks/vendor-hf-doc-builder.js";import{I as ce}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as _e}from"../../../chunks/CodeBlock-hf-doc-builder.js";function jn(Xo){let y,Qe,O,A,ge,I,Tt,ve,Nt,We,M,yt,ne,Ot,kt,Ue,k,P,we,Q,Et,be,jt,Be,f,Xt,xe,St,At,$e,Mt,Pt,qe,Rt,Ft,Te,Ht,Dt,Ve,R,Lt,Ne,zt,Ct,Ge,W,Ye,E,F,ye,U,It,Oe,Qt,Je,h,Wt,se,Ut,Bt,ke,Vt,Gt,ae,Yt,Jt,Ke,B,Ze,j,H,Ee,V,Kt,je,Zt,et,c,eo,G,to,oo,Xe,no,so,Y,ao,ro,tt,J,ot,X,D,Se,K,lo,Ae,io,nt,re,mo,st,$,Me,po,uo,Pe,fo,ho,Re,co,at,le,_o,rt,Z,lt,S,L,Fe,ee,go,He,vo,it,ie,wo,mt,q,De,bo,xo,Le,$o,qo,ze,To,pt,me,No,ut,te,dt,T,yo,Ce,Oo,ko,Ie,Eo,jo,ft,oe,ht,pe,ue,So,ct;return I=new ce({}),Q=new ce({}),W=new _e({props:{code:`from transformers import AutoTokenizer, pipeline
-from transformers import AutoModelForQuestionAnswering
+from optimum.onnxruntime import ORTModelForQuestionAnswering

-model = AutoModelForQuestionAnswering.from_pretrained("deepset/roberta-base-squad2") # PyTorch checkpoint
+model = ORTModelForQuestionAnswering.from_pretrained("optimum/roberta-base-squad2") # ONNX checkpoint
tokenizer = AutoTokenizer.from_pretrained("deepset/roberta-base-squad2")

onnx_qa = pipeline("question-answering",model=model,tokenizer=tokenizer)

question = "What's my name?"
context = "My name is Philipp and I live in Nuremberg."
pred = onnx_qa(question, context)`,highlighted:`from transformers import AutoTokenizer, pipeline
<span class="hljs-deletion">-from transformers import AutoModelForQuestionAnswering</span>
<span class="hljs-addition">+from optimum.onnxruntime import ORTModelForQuestionAnswering</span>

<span class="hljs-deletion">-model = AutoModelForQuestionAnswering.from_pretrained(&quot;deepset/roberta-base-squad2&quot;) # PyTorch checkpoint</span>
<span class="hljs-addition">+model = ORTModelForQuestionAnswering.from_pretrained(&quot;optimum/roberta-base-squad2&quot;) # ONNX checkpoint</span>
tokenizer = AutoTokenizer.from_pretrained(&quot;deepset/roberta-base-squad2&quot;)

onnx_qa = pipeline(&quot;question-answering&quot;,model=model,tokenizer=tokenizer)

question = &quot;What&#x27;s my name?&quot;
context = &quot;My name is Philipp and I live in Nuremberg.&quot;
pred = onnx_qa(question, context)`}}),U=new ce({}),B=new _e({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification

# Load the model from the hub and export it to the ONNX format
model = ORTModelForSequenceClassification.from_pretrained(
    "distilbert-base-uncased-finetuned-sst-2-english", from_transformers=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>, from_transformers=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),V=new ce({}),J=new _e({props:{code:`from optimum.onnxruntime import ORTModelForSequenceClassification

# Load the model from the hub and export it to the ONNX format
model = ORTModelForSequenceClassification.from_pretrained(
    "distilbert-base-uncased-finetuned-sst-2-english", from_transformers=True
)

# Save the converted model
model.save_pretrained("a_local_path_for_convert_onnx_model")

model.push_to_hub(
  "a_local_path_for_convert_onnx_model", repository_id="my-onnx-repo", use_auth_token=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>, from_transformers=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Save the converted model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.save_pretrained(<span class="hljs-string">&quot;a_local_path_for_convert_onnx_model&quot;</span>)

<span class="hljs-comment"># Push the onnx model to HF Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model.push_to_hub(
<span class="hljs-meta">... </span>  <span class="hljs-string">&quot;a_local_path_for_convert_onnx_model&quot;</span>, repository_id=<span class="hljs-string">&quot;my-onnx-repo&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),K=new ce({}),Z=new _e({props:{code:`from transformers import AutoTokenizer, pipeline
from optimum.onnxruntime import ORTModelForSeq2SeqLM

model_name = "t5-small"
model = ORTModelForSeq2SeqLM.from_pretrained(model_name, from_transformers=True)
tokenizer = AutoTokenizer.from_pretrained(model_name)

onnx_translation = pipeline("translation_en_to_fr", model=model, tokenizer=tokenizer)
text = "He never went out without a book under his arm, and he often came back with two."
result = onnx_translation(text)
# [{'translation_text': "Il n'est jamais sorti sans un livre sous son bras, et il est souvent revenu avec deux."}]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, pipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForSeq2SeqLM

<span class="hljs-comment"># Load the model from the hub and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_name = <span class="hljs-string">&quot;t5-small&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSeq2SeqLM.from_pretrained(model_name, from_transformers=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(model_name)

<span class="hljs-comment"># Create a pipeline</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_translation = pipeline(<span class="hljs-string">&quot;translation_en_to_fr&quot;</span>, model=model, tokenizer=tokenizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;He never went out without a book under his arm, and he often came back with two.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>result = onnx_translation(text)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># [{&#x27;translation_text&#x27;: &quot;Il n&#x27;est jamais sorti sans un livre sous son bras, et il est souvent revenu avec deux.&quot;}]</span>`}}),ee=new ce({}),te=new _e({props:{code:`from optimum.onnxruntime import ORTStableDiffusionPipeline

model_id = "runwayml/stable-diffusion-v1-5"
stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, revision="onnx")
prompt = "sailing ship in storm by Leonardo da Vinci"
image = stable_diffusion(prompt).images[0]`,highlighted:`<span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTStableDiffusionPipeline

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, revision=<span class="hljs-string">&quot;onnx&quot;</span>)
prompt = <span class="hljs-string">&quot;sailing ship in storm by Leonardo da Vinci&quot;</span>
image = stable_diffusion(prompt).images[<span class="hljs-number">0</span>]`}}),oe=new _e({props:{code:`stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, export=True)

# Save the exported model
save_directory = "a_local_path"
stable_diffusion.save_pretrained(save_directory)`,highlighted:`stable_diffusion = ORTStableDiffusionPipeline.from_pretrained(model_id, export=<span class="hljs-literal">True</span>)

<span class="hljs-comment"># Save the exported model</span>
save_directory = <span class="hljs-string">&quot;a_local_path&quot;</span>
stable_diffusion.save_pretrained(save_directory)`}}),{c(){y=n("meta"),Qe=p(),O=n("h1"),A=n("a"),ge=n("span"),_(I.$$.fragment),Tt=p(),ve=n("span"),Nt=l("Optimum Inference with ONNX Runtime"),We=p(),M=n("p"),yt=l(`Optimum is a utility package for building and running inference with accelerated runtime like ONNX Runtime.
Optimum can be used to load optimized models from the `),ne=n("a"),Ot=l("Hugging Face Hub"),kt=l(` and create pipelines
to run accelerated inference without rewriting your APIs.`),Ue=p(),k=n("h2"),P=n("a"),we=n("span"),_(Q.$$.fragment),Et=p(),be=n("span"),jt=l("Switching from Transformers to Optimum"),Be=p(),f=n("p"),Xt=l("The "),xe=n("code"),St=l("optimum.onnxruntime.ORTModelForXXX"),At=l(` model classes are API compatible with Hugging Face Transformers models. This
means you can just replace your `),$e=n("code"),Mt=l("AutoModelForXXX"),Pt=l(" class with the corresponding "),qe=n("code"),Rt=l("ORTModelForXXX"),Ft=l(" class in "),Te=n("code"),Ht=l("optimum.onnxruntime"),Dt=l("."),Ve=p(),R=n("p"),Lt=l("You do not need to adapt your code to get it to work with "),Ne=n("code"),zt=l("ORTModelForXXX"),Ct=l(" classes:"),Ge=p(),_(W.$$.fragment),Ye=p(),E=n("h3"),F=n("a"),ye=n("span"),_(U.$$.fragment),It=p(),Oe=n("span"),Qt=l("Loading a vanilla Transformers model"),Je=p(),h=n("p"),Wt=l("Because the model you want to work with might not be already converted to ONNX,  "),se=n("a"),Ut=l("ORTModel"),Bt=l(`
includes a method to convert vanilla Transformers models to ONNX ones. Simply pass `),ke=n("code"),Vt=l("from_transformers=True"),Gt=l(` to the
`),ae=n("a"),Yt=l("from_pretrained()"),Jt=l(" method, and your model will be loaded and converted to ONNX on-the-fly:"),Ke=p(),_(B.$$.fragment),Ze=p(),j=n("h3"),H=n("a"),Ee=n("span"),_(V.$$.fragment),Kt=p(),je=n("span"),Zt=l("Pushing ONNX models to the Hugging Face Hub"),et=p(),c=n("p"),eo=l("It is also possible, just as with regular "),G=n("a"),to=l("PreTrainedModel"),oo=l("s, to push your "),Xe=n("code"),no=l("ORTModelForXXX"),so=l(` to the
`),Y=n("a"),ao=l("Hugging Face Model Hub"),ro=l(":"),tt=p(),_(J.$$.fragment),ot=p(),X=n("h2"),D=n("a"),Se=n("span"),_(K.$$.fragment),lo=p(),Ae=n("span"),io=l("Export and inference of sequence-to-sequence models"),nt=p(),re=n("p"),mo=l(`Sequence-to-sequence (Seq2Seq) models can also be used when running inference with ONNX Runtime. When Seq2Seq models
are exported to the ONNX format, they are decomposed into three parts that are later combined during inference:`),st=p(),$=n("ul"),Me=n("li"),po=l("The encoder part of the model"),uo=p(),Pe=n("li"),fo=l("The decoder part of the model + the language modeling head"),ho=p(),Re=n("li"),co=l(`The same decoder part of the model + language modeling head but taking and using pre-computed key / values as inputs and
outputs. This makes inference faster.`),at=p(),le=n("p"),_o=l("Here is an example of how you can load a T5 model to the ONNX format and run inference for a translation task:"),rt=p(),_(Z.$$.fragment),lt=p(),S=n("h2"),L=n("a"),Fe=n("span"),_(ee.$$.fragment),go=p(),He=n("span"),vo=l("Export and inference of Stable Diffusion models"),it=p(),ie=n("p"),wo=l(`Stable Diffusion models can also be used when running inference with ONNX Runtime. When Stable Diffusion models
are exported to the ONNX format, they are split into three components that are later combined during inference:`),mt=p(),q=n("ul"),De=n("li"),bo=l("The text encoder"),xo=p(),Le=n("li"),$o=l("The U-NET"),qo=p(),ze=n("li"),To=l("The VAE decoder"),pt=p(),me=n("p"),No=l("Here is an example of how you can load an ONNX Stable Diffusion model and run inference using ONNX Runtime:"),ut=p(),_(te.$$.fragment),dt=p(),T=n("p"),yo=l("To load your PyTorch model and convert it to ONNX on-the-fly, you can set "),Ce=n("code"),Oo=l("export=True"),ko=l(`.
Don\u2019t forget to save the resulting ONNX model using the `),Ie=n("code"),Eo=l("save_pretrained"),jo=l(" method."),ft=p(),_(oe.$$.fragment),ht=p(),pe=n("p"),ue=n("img"),this.h()},l(e){const r=yn('[data-svelte="svelte-1phssyn"]',document.head);y=s(r,"META",{name:!0,content:!0}),r.forEach(t),Qe=u(e),O=s(e,"H1",{class:!0});var _t=a(O);A=s(_t,"A",{id:!0,class:!0,href:!0});var Ao=a(A);ge=s(Ao,"SPAN",{});var Mo=a(ge);g(I.$$.fragment,Mo),Mo.forEach(t),Ao.forEach(t),Tt=u(_t),ve=s(_t,"SPAN",{});var Po=a(ve);Nt=i(Po,"Optimum Inference with ONNX Runtime"),Po.forEach(t),_t.forEach(t),We=u(e),M=s(e,"P",{});var gt=a(M);yt=i(gt,`Optimum is a utility package for building and running inference with accelerated runtime like ONNX Runtime.
Optimum can be used to load optimized models from the `),ne=s(gt,"A",{href:!0});var Ro=a(ne);Ot=i(Ro,"Hugging Face Hub"),Ro.forEach(t),kt=i(gt,` and create pipelines
to run accelerated inference without rewriting your APIs.`),gt.forEach(t),Ue=u(e),k=s(e,"H2",{class:!0});var vt=a(k);P=s(vt,"A",{id:!0,class:!0,href:!0});var Fo=a(P);we=s(Fo,"SPAN",{});var Ho=a(we);g(Q.$$.fragment,Ho),Ho.forEach(t),Fo.forEach(t),Et=u(vt),be=s(vt,"SPAN",{});var Do=a(be);jt=i(Do,"Switching from Transformers to Optimum"),Do.forEach(t),vt.forEach(t),Be=u(e),f=s(e,"P",{});var N=a(f);Xt=i(N,"The "),xe=s(N,"CODE",{});var Lo=a(xe);St=i(Lo,"optimum.onnxruntime.ORTModelForXXX"),Lo.forEach(t),At=i(N,` model classes are API compatible with Hugging Face Transformers models. This
means you can just replace your `),$e=s(N,"CODE",{});var zo=a($e);Mt=i(zo,"AutoModelForXXX"),zo.forEach(t),Pt=i(N," class with the corresponding "),qe=s(N,"CODE",{});var Co=a(qe);Rt=i(Co,"ORTModelForXXX"),Co.forEach(t),Ft=i(N," class in "),Te=s(N,"CODE",{});var Io=a(Te);Ht=i(Io,"optimum.onnxruntime"),Io.forEach(t),Dt=i(N,"."),N.forEach(t),Ve=u(e),R=s(e,"P",{});var wt=a(R);Lt=i(wt,"You do not need to adapt your code to get it to work with "),Ne=s(wt,"CODE",{});var Qo=a(Ne);zt=i(Qo,"ORTModelForXXX"),Qo.forEach(t),Ct=i(wt," classes:"),wt.forEach(t),Ge=u(e),g(W.$$.fragment,e),Ye=u(e),E=s(e,"H3",{class:!0});var bt=a(E);F=s(bt,"A",{id:!0,class:!0,href:!0});var Wo=a(F);ye=s(Wo,"SPAN",{});var Uo=a(ye);g(U.$$.fragment,Uo),Uo.forEach(t),Wo.forEach(t),It=u(bt),Oe=s(bt,"SPAN",{});var Bo=a(Oe);Qt=i(Bo,"Loading a vanilla Transformers model"),Bo.forEach(t),bt.forEach(t),Je=u(e),h=s(e,"P",{});var z=a(h);Wt=i(z,"Because the model you want to work with might not be already converted to ONNX,  "),se=s(z,"A",{href:!0});var Vo=a(se);Ut=i(Vo,"ORTModel"),Vo.forEach(t),Bt=i(z,`
includes a method to convert vanilla Transformers models to ONNX ones. Simply pass `),ke=s(z,"CODE",{});var Go=a(ke);Vt=i(Go,"from_transformers=True"),Go.forEach(t),Gt=i(z,` to the
`),ae=s(z,"A",{href:!0});var Yo=a(ae);Yt=i(Yo,"from_pretrained()"),Yo.forEach(t),Jt=i(z," method, and your model will be loaded and converted to ONNX on-the-fly:"),z.forEach(t),Ke=u(e),g(B.$$.fragment,e),Ze=u(e),j=s(e,"H3",{class:!0});var xt=a(j);H=s(xt,"A",{id:!0,class:!0,href:!0});var Jo=a(H);Ee=s(Jo,"SPAN",{});var Ko=a(Ee);g(V.$$.fragment,Ko),Ko.forEach(t),Jo.forEach(t),Kt=u(xt),je=s(xt,"SPAN",{});var Zo=a(je);Zt=i(Zo,"Pushing ONNX models to the Hugging Face Hub"),Zo.forEach(t),xt.forEach(t),et=u(e),c=s(e,"P",{});var C=a(c);eo=i(C,"It is also possible, just as with regular "),G=s(C,"A",{href:!0,rel:!0});var en=a(G);to=i(en,"PreTrainedModel"),en.forEach(t),oo=i(C,"s, to push your "),Xe=s(C,"CODE",{});var tn=a(Xe);no=i(tn,"ORTModelForXXX"),tn.forEach(t),so=i(C,` to the
`),Y=s(C,"A",{href:!0,rel:!0});var on=a(Y);ao=i(on,"Hugging Face Model Hub"),on.forEach(t),ro=i(C,":"),C.forEach(t),tt=u(e),g(J.$$.fragment,e),ot=u(e),X=s(e,"H2",{class:!0});var $t=a(X);D=s($t,"A",{id:!0,class:!0,href:!0});var nn=a(D);Se=s(nn,"SPAN",{});var sn=a(Se);g(K.$$.fragment,sn),sn.forEach(t),nn.forEach(t),lo=u($t),Ae=s($t,"SPAN",{});var an=a(Ae);io=i(an,"Export and inference of sequence-to-sequence models"),an.forEach(t),$t.forEach(t),nt=u(e),re=s(e,"P",{});var rn=a(re);mo=i(rn,`Sequence-to-sequence (Seq2Seq) models can also be used when running inference with ONNX Runtime. When Seq2Seq models
are exported to the ONNX format, they are decomposed into three parts that are later combined during inference:`),rn.forEach(t),st=u(e),$=s(e,"UL",{});var de=a($);Me=s(de,"LI",{});var ln=a(Me);po=i(ln,"The encoder part of the model"),ln.forEach(t),uo=u(de),Pe=s(de,"LI",{});var mn=a(Pe);fo=i(mn,"The decoder part of the model + the language modeling head"),mn.forEach(t),ho=u(de),Re=s(de,"LI",{});var pn=a(Re);co=i(pn,`The same decoder part of the model + language modeling head but taking and using pre-computed key / values as inputs and
outputs. This makes inference faster.`),pn.forEach(t),de.forEach(t),at=u(e),le=s(e,"P",{});var un=a(le);_o=i(un,"Here is an example of how you can load a T5 model to the ONNX format and run inference for a translation task:"),un.forEach(t),rt=u(e),g(Z.$$.fragment,e),lt=u(e),S=s(e,"H2",{class:!0});var qt=a(S);L=s(qt,"A",{id:!0,class:!0,href:!0});var dn=a(L);Fe=s(dn,"SPAN",{});var fn=a(Fe);g(ee.$$.fragment,fn),fn.forEach(t),dn.forEach(t),go=u(qt),He=s(qt,"SPAN",{});var hn=a(He);vo=i(hn,"Export and inference of Stable Diffusion models"),hn.forEach(t),qt.forEach(t),it=u(e),ie=s(e,"P",{});var cn=a(ie);wo=i(cn,`Stable Diffusion models can also be used when running inference with ONNX Runtime. When Stable Diffusion models
are exported to the ONNX format, they are split into three components that are later combined during inference:`),cn.forEach(t),mt=u(e),q=s(e,"UL",{});var fe=a(q);De=s(fe,"LI",{});var _n=a(De);bo=i(_n,"The text encoder"),_n.forEach(t),xo=u(fe),Le=s(fe,"LI",{});var gn=a(Le);$o=i(gn,"The U-NET"),gn.forEach(t),qo=u(fe),ze=s(fe,"LI",{});var vn=a(ze);To=i(vn,"The VAE decoder"),vn.forEach(t),fe.forEach(t),pt=u(e),me=s(e,"P",{});var wn=a(me);No=i(wn,"Here is an example of how you can load an ONNX Stable Diffusion model and run inference using ONNX Runtime:"),wn.forEach(t),ut=u(e),g(te.$$.fragment,e),dt=u(e),T=s(e,"P",{});var he=a(T);yo=i(he,"To load your PyTorch model and convert it to ONNX on-the-fly, you can set "),Ce=s(he,"CODE",{});var bn=a(Ce);Oo=i(bn,"export=True"),bn.forEach(t),ko=i(he,`.
Don\u2019t forget to save the resulting ONNX model using the `),Ie=s(he,"CODE",{});var xn=a(Ie);Eo=i(xn,"save_pretrained"),xn.forEach(t),jo=i(he," method."),he.forEach(t),ft=u(e),g(oe.$$.fragment,e),ht=u(e),pe=s(e,"P",{});var $n=a(pe);ue=s($n,"IMG",{src:!0,alt:!0}),$n.forEach(t),this.h()},h(){d(y,"name","hf:doc:metadata"),d(y,"content",JSON.stringify(Xn)),d(A,"id","optimum-inference-with-onnx-runtime"),d(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(A,"href","#optimum-inference-with-onnx-runtime"),d(O,"class","relative group"),d(ne,"href","hf.co/models"),d(P,"id","switching-from-transformers-to-optimum"),d(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(P,"href","#switching-from-transformers-to-optimum"),d(k,"class","relative group"),d(F,"id","loading-a-vanilla-transformers-model"),d(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(F,"href","#loading-a-vanilla-transformers-model"),d(E,"class","relative group"),d(se,"href","/docs/optimum/main/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel"),d(ae,"href","/docs/optimum/main/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel.from_pretrained"),d(H,"id","pushing-onnx-models-to-the-hugging-face-hub"),d(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(H,"href","#pushing-onnx-models-to-the-hugging-face-hub"),d(j,"class","relative group"),d(G,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),d(G,"rel","nofollow"),d(Y,"href","https://hf.co/models"),d(Y,"rel","nofollow"),d(D,"id","export-and-inference-of-sequencetosequence-models"),d(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(D,"href","#export-and-inference-of-sequencetosequence-models"),d(X,"class","relative group"),d(L,"id","export-and-inference-of-stable-diffusion-models"),d(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(L,"href","#export-and-inference-of-stable-diffusion-models"),d(S,"class","relative group"),On(ue.src,So="https://huggingface.co/datasets/optimum/documentation-images/resolve/main/onnxruntime/stable_diffusion_v1_5_ort_sail_boat.png")||d(ue,"src",So),d(ue,"alt","img")},m(e,r){o(document.head,y),m(e,Qe,r),m(e,O,r),o(O,A),o(A,ge),v(I,ge,null),o(O,Tt),o(O,ve),o(ve,Nt),m(e,We,r),m(e,M,r),o(M,yt),o(M,ne),o(ne,Ot),o(M,kt),m(e,Ue,r),m(e,k,r),o(k,P),o(P,we),v(Q,we,null),o(k,Et),o(k,be),o(be,jt),m(e,Be,r),m(e,f,r),o(f,Xt),o(f,xe),o(xe,St),o(f,At),o(f,$e),o($e,Mt),o(f,Pt),o(f,qe),o(qe,Rt),o(f,Ft),o(f,Te),o(Te,Ht),o(f,Dt),m(e,Ve,r),m(e,R,r),o(R,Lt),o(R,Ne),o(Ne,zt),o(R,Ct),m(e,Ge,r),v(W,e,r),m(e,Ye,r),m(e,E,r),o(E,F),o(F,ye),v(U,ye,null),o(E,It),o(E,Oe),o(Oe,Qt),m(e,Je,r),m(e,h,r),o(h,Wt),o(h,se),o(se,Ut),o(h,Bt),o(h,ke),o(ke,Vt),o(h,Gt),o(h,ae),o(ae,Yt),o(h,Jt),m(e,Ke,r),v(B,e,r),m(e,Ze,r),m(e,j,r),o(j,H),o(H,Ee),v(V,Ee,null),o(j,Kt),o(j,je),o(je,Zt),m(e,et,r),m(e,c,r),o(c,eo),o(c,G),o(G,to),o(c,oo),o(c,Xe),o(Xe,no),o(c,so),o(c,Y),o(Y,ao),o(c,ro),m(e,tt,r),v(J,e,r),m(e,ot,r),m(e,X,r),o(X,D),o(D,Se),v(K,Se,null),o(X,lo),o(X,Ae),o(Ae,io),m(e,nt,r),m(e,re,r),o(re,mo),m(e,st,r),m(e,$,r),o($,Me),o(Me,po),o($,uo),o($,Pe),o(Pe,fo),o($,ho),o($,Re),o(Re,co),m(e,at,r),m(e,le,r),o(le,_o),m(e,rt,r),v(Z,e,r),m(e,lt,r),m(e,S,r),o(S,L),o(L,Fe),v(ee,Fe,null),o(S,go),o(S,He),o(He,vo),m(e,it,r),m(e,ie,r),o(ie,wo),m(e,mt,r),m(e,q,r),o(q,De),o(De,bo),o(q,xo),o(q,Le),o(Le,$o),o(q,qo),o(q,ze),o(ze,To),m(e,pt,r),m(e,me,r),o(me,No),m(e,ut,r),v(te,e,r),m(e,dt,r),m(e,T,r),o(T,yo),o(T,Ce),o(Ce,Oo),o(T,ko),o(T,Ie),o(Ie,Eo),o(T,jo),m(e,ft,r),v(oe,e,r),m(e,ht,r),m(e,pe,r),o(pe,ue),ct=!0},p:kn,i(e){ct||(w(I.$$.fragment,e),w(Q.$$.fragment,e),w(W.$$.fragment,e),w(U.$$.fragment,e),w(B.$$.fragment,e),w(V.$$.fragment,e),w(J.$$.fragment,e),w(K.$$.fragment,e),w(Z.$$.fragment,e),w(ee.$$.fragment,e),w(te.$$.fragment,e),w(oe.$$.fragment,e),ct=!0)},o(e){b(I.$$.fragment,e),b(Q.$$.fragment,e),b(W.$$.fragment,e),b(U.$$.fragment,e),b(B.$$.fragment,e),b(V.$$.fragment,e),b(J.$$.fragment,e),b(K.$$.fragment,e),b(Z.$$.fragment,e),b(ee.$$.fragment,e),b(te.$$.fragment,e),b(oe.$$.fragment,e),ct=!1},d(e){t(y),e&&t(Qe),e&&t(O),x(I),e&&t(We),e&&t(M),e&&t(Ue),e&&t(k),x(Q),e&&t(Be),e&&t(f),e&&t(Ve),e&&t(R),e&&t(Ge),x(W,e),e&&t(Ye),e&&t(E),x(U),e&&t(Je),e&&t(h),e&&t(Ke),x(B,e),e&&t(Ze),e&&t(j),x(V),e&&t(et),e&&t(c),e&&t(tt),x(J,e),e&&t(ot),e&&t(X),x(K),e&&t(nt),e&&t(re),e&&t(st),e&&t($),e&&t(at),e&&t(le),e&&t(rt),x(Z,e),e&&t(lt),e&&t(S),x(ee),e&&t(it),e&&t(ie),e&&t(mt),e&&t(q),e&&t(pt),e&&t(me),e&&t(ut),x(te,e),e&&t(dt),e&&t(T),e&&t(ft),x(oe,e),e&&t(ht),e&&t(pe)}}}const Xn={local:"optimum-inference-with-onnx-runtime",sections:[{local:"switching-from-transformers-to-optimum",sections:[{local:"loading-a-vanilla-transformers-model",title:"Loading a vanilla Transformers model"},{local:"pushing-onnx-models-to-the-hugging-face-hub",title:"Pushing ONNX models to the Hugging Face Hub"}],title:"Switching from Transformers to Optimum"},{local:"export-and-inference-of-sequencetosequence-models",title:"Export and inference of sequence-to-sequence models"},{local:"export-and-inference-of-stable-diffusion-models",title:"Export and inference of Stable Diffusion models"}],title:"Optimum Inference with ONNX Runtime"};function Sn(Xo){return En(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rn extends qn{constructor(y){super();Tn(this,y,Sn,jn,Nn,{})}}export{Rn as default,Xn as metadata};
